-- Performance view to store historical performance data from
-- snapshot administrative view sysibmadm.snaptab
-- Downloaded from http://www.ebenner.com/db2luwdba-howto
-- Please direct any questions to consulting@ebenner.com

create table dba.snaptab (
SNAPSHOT_TIMESTAMP TIMESTAMP not null,
TABSCHEMA VARCHAR(128) not null,
TABNAME VARCHAR(128) not null,
TAB_FILE_ID BIGINT,
TAB_TYPE VARCHAR(14),
DATA_OBJECT_PAGES BIGINT,
INDEX_OBJECT_PAGES BIGINT,
LOB_OBJECT_PAGES BIGINT,
LONG_OBJECT_PAGES BIGINT,
XDA_OBJECT_PAGES BIGINT,
ROWS_READ BIGINT,
ROWS_WRITTEN BIGINT,
OVERFLOW_ACCESSES BIGINT,
PAGE_REORGS BIGINT,
DBPARTITIONNUM SMALLINT,
TBSP_ID BIGINT,
DATA_PARTITION_ID INTEGER )
IN "some-data-tablespace" INDEX IN "some-index-tablespace" ;
commit;

CREATE UNIQUE INDEX DBA.PK_SNAPTAB ON DBA.SNAPTAB
                (SNAPSHOT_TIMESTAMP ASC, TABSCHEMA ASC, TABNAME ASC) ;
commit;

-- DDL Statements for primary key on Table

ALTER TABLE DBA.SNAPTAB
        ADD CONSTRAINT PK_SNAPTAB PRIMARY KEY
                (SNAPSHOT_TIMESTAMP, TABSCHEMA, TABNAME );
commit;
